<?php

include_once("Components/paymentServiceInvokerBase.php5");   

// Generation of secure (WS-security) soap-request
class httpConPaymentServiceInvoker extends PaymentServiceInvokerBase
{					
	// Creation of pox-request for getRedirectData web-method
	function getRedirectData($userID,$amount){ 
	global $CONFIGURATION_VALUES;
			
	// Initialize data for WS header
	$this->setWSData();
			
			
	// main template for pox-request            
	$xml = '<?xml version="1.0" encoding="utf-8"?>'.
		'<getRedirectDataRequest xmlns="http://www.cqrpayments.com/PaymentProcessing"
			xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
			xmlns:xsd="http://www.w3.org/2001/XMLSchema">'.
		'         <merchantID>'.ConfigurationHelper::GetMerchant().'</merchantID>'.
		'         <redirectParameters xsi:type="paymentMethodSelectionWithDetailsRedirectParameters">'.
		'                <shopID>'.ConfigurationHelper::GetShop().'</shopID>'.
		'                <httpMethod>POST</httpMethod>'.
		'                <returnUrl>'.ConfigurationHelper::GetReturnUrl().'</returnUrl>'.
		'                <languageCode>'.ConfigurationHelper::GetLanguage().'</languageCode>'.
		'                <currencyCode>'.ConfigurationHelper::GetCurrency().'</currencyCode>'.
		'                <countryCode>'.ConfigurationHelper::GetCountry().'</countryCode>'.
		'                <user>'.
		'                   <id>'.$userID.'</id>'.
		'                   <username xsi:nil="true"/>'.
		'                   <firstname xsi:nil="true"/>'.
		'                   <lastname xsi:nil="true"/>'.
		'                   <currencyCode xsi:nil="true"/>'.
		'                   <languageCode xsi:nil="true"/>'.
		'                   <email xsi:nil="true"/>'.
		'                   <address xsi:nil="true"/>'.
		'                </user>'.
		'                <merchantTransactionID>'.$this->paymentId.'</merchantTransactionID>'.
		'                <grossAmount>'.$amount.'</grossAmount>'.
		'                <minPaymentLimitAmount>10</minPaymentLimitAmount>'.
		'                <maxPaymentLimitAmount>3000</maxPaymentLimitAmount>'.
		'                <expirationTimeSpanInSeconds>1200</expirationTimeSpanInSeconds>'.
		'                <successUrl>'.ConfigurationHelper::GetSuccessUrl().'?PID='.$this->paymentId.'</successUrl>'.
		'                <pendingUrl>'.ConfigurationHelper::GetPendingUrl().'</pendingUrl>'.
		'                <errorUrl>'.ConfigurationHelper::GetErrorUrl().'?PID='.$this->paymentId.'</errorUrl>'.
		'                <cancelUrl>'.ConfigurationHelper::GetCancelUrl().'</cancelUrl>'.
		'                <refusedUrl>'.ConfigurationHelper::GetRefusedUrl().'</refusedUrl>'.
		'                <paymentDirection>Deposit</paymentDirection>'.
		'         </redirectParameters>'.
		'</getRedirectDataRequest>';
			
	$CQRresult = $this->AssembleAndSendPOXRequest($xml,"getRedirectData");
			
	preg_match_all("/<redirectUrl>(.*)<\/redirectUrl>/",$CQRresult,$urls);
	$redirectUrl = $urls[1][0];
	preg_match_all("/<dataField><key>requestData<\/key><value>(.*)<\/value><\/dataField>/",$CQRresult,$dataFields);
	$dataField = $dataFields[1][0];
			
	if(!$redirectUrl || !$dataField){
		echo "<h3>Error!</h3>";
		print_r($CQRresult);
		exit;
	}
			
	return new redirectData($redirectUrl,$dataField);
	}  
		
	// Creation of pox-request for getPayments web-method
	function getPayments($merchantTransactionID, $isExecuted){ 
	global $CONFIGURATION_VALUES;
			
	// Initialize data for WS header
	$this->setWSData();
			
	// Creation of pox-body
	$xml =
		'<getPaymentsRequest xmlns="http://www.cqrpayments.com/PaymentProcessing" 
			xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" 
			xmlns:xsd="http://www.w3.org/2001/XMLSchema">'."\n".
		'<merchantID>'.ConfigurationHelper::GetMerchant().'</merchantID>'."\n".
		'<shopID>'.ConfigurationHelper::GetShop().'</shopID>'."\n".
		'<merchantTransactionID>'.$merchantTransactionID.'</merchantTransactionID>'."\n".
		'<isExecuted>'.$isExecuted.'</isExecuted>'."\n".
		'</getPaymentsRequest>'."\n";
			
	if(!$isExecuted) $xml = str_replace("<isExecuted></isExecuted>","<isExecuted xsi:nil='true'/>",$xml);				          
			
	$CQRresult = $this->AssembleAndSendPOXRequest($xml,"getPayments");
			
	preg_match_all("/<payments>(.*)<\/payments>/",$CQRresult,$result);
	$payments = $this->xml2array($result[1][0]);
			
	return $payments;
	}  
}


