<?php
include_once("Components/paymentServiceInvokerBase.php5");   

// Generation of secure (WS-security) soap-request
class SoapPaymentServiceInvoker extends PaymentServiceInvokerBase
{				
	// Creation of soap-request for getRedirectData web-method
	function getRedirectData($userID,$amount){ 
		global $CONFIGURATION_VALUES;
		
		// Initialize data for WS header
		$this->setWSData();
		
            //echo ":".storedit_db_praefix_vivuem.".".$this->paymentId."-";

            $update_bestellung_sql="UPDATE ".storedit_db_praefix_vivuem."_bestellungen SET pruefsumme='$this->paymentId' WHERE bestellNr='$userID'";
            $update_bestellung_query=mysqli_query($db_mysqli, $update_bestellung_sql);
            //echo $update_bestellung_query."-update-";
            
            
		// Creation of soap-body
		$xml_body =
			'<getRedirectDataRequest xmlns="http://www.cqrpayments.com/PaymentProcessing">'."\n".
			'<merchantID>'.ConfigurationHelper::GetMerchant().'</merchantID>'."\n".
			'<redirectParameters xsi:type="paymentMethodSelectionWithDetailsRedirectParameters">'."\n".
			' <shopID>'.ConfigurationHelper::GetShop().'</shopID>'."\n".
			' <httpMethod>POST</httpMethod>'."\n".
			' <returnUrl>'.ConfigurationHelper::GetReturnUrl().'</returnUrl>'."\n".
			' <languageCode>'.ConfigurationHelper::GetLanguage().'</languageCode>'."\n".
			' <currencyCode>'.ConfigurationHelper::GetCurrency().'</currencyCode>'."\n".
			' <countryCode>'.ConfigurationHelper::GetCountry().'</countryCode>'."\n".
			' <user>'."\n".
			'   <id>'.$userID.'</id>'."\n".
			' </user>'."\n".
			' <merchantTransactionID>'.$this->paymentId.'</merchantTransactionID>'."\n".
			' <grossAmount>'.$amount.'</grossAmount>'."\n".
			' <successUrl>'.ConfigurationHelper::GetSuccessUrl().'?PID='.$this->paymentId.'</successUrl>'."\n".
			' <pendingUrl>'.ConfigurationHelper::GetPendingUrl().'</pendingUrl>'."\n".
			' <errorUrl>'.ConfigurationHelper::GetErrorUrl().'?PID='.$this->paymentId.'</errorUrl>'."\n".
			' <cancelUrl>'.ConfigurationHelper::GetCancelUrl().'</cancelUrl>'."\n".
			' <refusedUrl>'.ConfigurationHelper::GetRefusedUrl().'</refusedUrl>'."\n".
			' <paymentDirection>Deposit</paymentDirection>'."\n".
			'</redirectParameters>'."\n".
			'</getRedirectDataRequest>'."\n";
		
		$CQRresult = $this->AssembleAndSendSoapRequest($xml_body,"getRedirectData");
		
		preg_match_all("/<redirectUrl>(.*)<\/redirectUrl>/",$CQRresult,$urls);
		$redirectUrl = $urls[1][0];
		preg_match_all("/<dataField><key>requestData<\/key><value>(.*)<\/value><\/dataField>/",$CQRresult,$dataFields);
		$dataField = $dataFields[1][0];
		
		if(!$redirectUrl || !$dataField){
			echo "<h3>Error!</h3>";
			print_r($CQRresult);
			exit;
		}
		
		// Values for matching in the Success page
		$result["merchantTransactionID"] = $this->paymentId;
		$result["shopID"] = ConfigurationHelper::GetShop();
		$result["grossAmount"] = $amount;
		$_SESSION["matchingResult"] = $result;
		
		return new redirectData($redirectUrl,$dataField);
	}  
	
	// Creation of soap-request for getPayments web-method
	function getPayments($merchantTransactionID, $isExecuted){ 
		global $CONFIGURATION_VALUES;
		
		// Initialize data for WS header
		$this->setWSData();
		
		// Creation of soap-body
		$xml_body =
			'<getPaymentsRequest xmlns="http://www.cqrpayments.com/PaymentProcessing" 
				xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" 
				xmlns:xsd="http://www.w3.org/2001/XMLSchema">'."\n".
			'<merchantID>'.ConfigurationHelper::GetMerchant().'</merchantID>'."\n".
			'<shopID>'.ConfigurationHelper::GetShop().'</shopID>'."\n".
			'<merchantTransactionID>'.$merchantTransactionID.'</merchantTransactionID>'."\n".
			'<isExecuted>'.$isExecuted.'</isExecuted>'."\n".
			'</getPaymentsRequest>'."\n";
		
		if(!$isExecuted) $xml_body = str_replace("<isExecuted></isExecuted>","<isExecuted xsi:nil='true'/>",$xml_body);
		
		$CQRresult = $this->AssembleAndSendSoapRequest($xml_body,"getPayments");
		
		preg_match_all("/<payments>(.*)<\/payments>/",$CQRresult,$result);
		$payments = $this->xml2array($result[1][0]);
		
		return $payments;
	}     
	/*
	// Creation of pox-request for getRedirectData web-method
	function getRedirectDataPOX($userID,$amount){ 
	global $CONFIGURATION_VALUES;
			
	// Initialize data for WS header
	$this->setWSData();
			
			
	// main template for pox-request            
	$xml = '<?xml version="1.0" encoding="utf-8"?>'.
		'<getRedirectDataRequest xmlns="http://www.cqrpayments.com/PaymentProcessing"
			xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
			xmlns:xsd="http://www.w3.org/2001/XMLSchema">'.
		'         <merchantID>'.ConfigurationHelper::GetMerchant().'</merchantID>'.
		'         <redirectParameters xsi:type="paymentMethodSelectionWithDetailsRedirectParameters">'.
		'                <shopID>'.ConfigurationHelper::GetShop().'</shopID>'.
		'                <httpMethod>POST</httpMethod>'.
		'                <returnUrl>'.ConfigurationHelper::GetReturnUrl().'</returnUrl>'.
		'                <languageCode>'.ConfigurationHelper::GetLanguage().'</languageCode>'.
		'                <currencyCode>'.ConfigurationHelper::GetCurrency().'</currencyCode>'.
		'                <countryCode>'.ConfigurationHelper::GetCountry().'</countryCode>'.
		'                <user>'.
		'                   <id>'.$userID.'</id>'.
		'                   <username xsi:nil="true"/>'.
		'                   <firstname xsi:nil="true"/>'.
		'                   <lastname xsi:nil="true"/>'.
		'                   <currencyCode xsi:nil="true"/>'.
		'                   <languageCode xsi:nil="true"/>'.
		'                   <email xsi:nil="true"/>'.
		'                   <address xsi:nil="true"/>'.
		'                </user>'.
		'                <merchantTransactionID>'.$this->paymentId.'</merchantTransactionID>'.
		'                <grossAmount>'.$amount.'</grossAmount>'.
		'                <minPaymentLimitAmount>10</minPaymentLimitAmount>'.
		'                <maxPaymentLimitAmount>3000</maxPaymentLimitAmount>'.
		'                <expirationTimeSpanInSeconds>1200</expirationTimeSpanInSeconds>'.
		'                <successUrl>'.ConfigurationHelper::GetSuccessUrl().'?PID='.$this->paymentId.'</successUrl>'.
		'                <pendingUrl>'.ConfigurationHelper::GetPendingUrl().'</pendingUrl>'.
		'                <errorUrl>'.ConfigurationHelper::GetErrorUrl().'?PID='.$this->paymentId.'</errorUrl>'.
		'                <cancelUrl>'.ConfigurationHelper::GetCancelUrl().'</cancelUrl>'.
		'                <refusedUrl>'.ConfigurationHelper::GetRefusedUrl().'</refusedUrl>'.
		'                <paymentDirection>Deposit</paymentDirection>'.
		'         </redirectParameters>'.
		'</getRedirectDataRequest>';
			
	$CQRresult = $this->AssembleAndSendPOXRequest($xml,"getRedirectData");
			
	preg_match_all("/<redirectUrl>(.*)<\/redirectUrl>/",$CQRresult,$urls);
	$redirectUrl = $urls[1][0];
	preg_match_all("/<dataField><key>requestData<\/key><value>(.*)<\/value><\/dataField>/",$CQRresult,$dataFields);
	$dataField = $dataFields[1][0];
			
	if(!$redirectUrl || !$dataField){
		echo "<h3>Error!</h3>";
		print_r($CQRresult);
		exit;
	}
			
	return new redirectData($redirectUrl,$dataField);
	}  
		
	// Creation of pox-request for getPayments web-method
	function getPaymentsPOX($merchantTransactionID, $isExecuted){ 
	global $CONFIGURATION_VALUES;
			
	// Initialize data for WS header
	$this->setWSData();
			
	// Creation of pox-body
	$xml =
		'<getPaymentsRequest xmlns="http://www.cqrpayments.com/PaymentProcessing" 
			xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" 
			xmlns:xsd="http://www.w3.org/2001/XMLSchema">'."\n".
		'<merchantID>'.ConfigurationHelper::GetMerchant().'</merchantID>'."\n".
		'<shopID>'.ConfigurationHelper::GetShop().'</shopID>'."\n".
		'<merchantTransactionID>'.$merchantTransactionID.'</merchantTransactionID>'."\n".
		'<isExecuted>'.$isExecuted.'</isExecuted>'."\n".
		'</getPaymentsRequest>'."\n";
			
	if(!$isExecuted) $xml = str_replace("<isExecuted></isExecuted>","<isExecuted xsi:nil='true'/>",$xml);				          
			
	$CQRresult = $this->AssembleAndSendPOXRequest($xml,"getPayments");
			
	preg_match_all("/<payments>(.*)<\/payments>/",$CQRresult,$result);
	$payments = $this->xml2array($result[1][0]);
			
	return $payments;
	}  
	*/
	
	
}


